/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.39 by edhill, Fri Nov 14 19:01:36 2003 UTC revision 1.83 by adcroft, Tue Jul 6 18:06:49 2004 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /usr/bin/env sh
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          printf "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 62  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -e Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -e "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -e Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161  # Guess possible config options for this host  # Guess possible config options for this host
162  find_possible_configs()  {  find_possible_configs()  {
163    
164      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
165      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
166      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
167      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
168        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
169        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
170        PLATFORM=$tmp3
171        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
172      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
173      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
174            
175      echo "test" > test      echo "test" > test
176      ln -s ./test link      ln -s ./test link
# Line 104  find_possible_configs()  { Line 188  find_possible_configs()  {
188          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
189      fi      fi
190    
191      # makedepend is not always available      #  The "original" makedepend is part of the Imake system that is
192        #  most often distributed with XFree86 or with an XFree86 source
193        #  package.  As a result, many machines (eg. generic Linux) do not
194        #  have a system-default "makedepend" available.  For those
195        #  systems, we have two fall-back options:
196        #
197        #    1) a makedepend implementation shipped with the cyrus-imapd
198        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
199        #
200        #    2) a known-buggy xmakedpend shell script
201        #
202        #  So the choices are, in order:
203        #
204        #    1) use the user-specified program
205        #    2) use a system-wide default
206        #    3) locally build and use the cyrus implementation
207        #    4) fall back to the buggy local xmakedpend script
208        #
209      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
210        which makedepend >& /dev/null        which makedepend > /dev/null 2>&1
211        RETVAL=$?        RV0=$?
212        if test "x${RETVAL}" = x1 ; then        cat <<EOF >> genmake_tc.f
213           echo "    makedepend was not found. Using xmakedpend instead."        program test
214           MAKEDEPEND='$(TOOLSDIR)/xmakedepend'        write(*,*) 'test'
215          stop
216          end
217    EOF
218          makedepend genmake_tc.f > /dev/null 2>&1
219          RV1=$?
220          if test ! "x${RV0}${RV1}" = x00 ; then
221             echo "    a system-default makedepend was not found."
222    
223             #  Try to build the cyrus impl
224             rm -f ./genmake_cy_md
225             (
226                 cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
227                     &&  ./configure > /dev/null 2>&1  \
228                     &&  make > /dev/null 2>&1
229                 if test -x ./makedepend.exe ; then
230                     $LN ./makedepend.exe ./makedepend
231                 fi
232                 ./makedepend ifparser.c > /dev/null 2>&1  \
233                     &&  echo "true"
234             ) > ./genmake_cy_md
235             grep true ./genmake_cy_md > /dev/null 2>&1
236             RETVAL=$?
237             if test "x$RETVAL" = x0 ; then
238                 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
239             else
240                 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
241             fi
242             rm -f ./genmake_cy_md
243        fi        fi
244      fi      fi
245    
# Line 149  EOF Line 278  EOF
278          echo "   "$p_FC          echo "   "$p_FC
279          if test "x$FC" = x ; then          if test "x$FC" = x ; then
280              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
281                echo "  Setting FORTRAN compiler to: "$FC
282          fi          fi
283      fi      fi
284    
285      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
286          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
287          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
288              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
289              echo "  The options file:  $p_OF"          fi
290              echo "    appears to match so we'll use it."      fi
291              break  #    echo "  The options file:  $p_OF"
292          fi  #    echo "    appears to match so we'll use it."
293      done  #   for i in $p_FC ; do
294    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
295    #if test -r $p_OF ; then
296    #    OPTFILE=$p_OF
297    #    echo "  The options file:  $p_OF"
298    #    echo "    appears to match so we'll use it."
299    #    break
300    #fi
301    #   done
302      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
303          cat 1>&2 <<EOF          cat 1>&2 <<EOF
304    
# Line 219  get_pdepend_list()  { Line 357  get_pdepend_list()  {
357      . ./.pd_tmp      . ./.pd_tmp
358      rm -f ./.pd_tmp      rm -f ./.pd_tmp
359    
360      echo -n "PNAME = "${}      printf "PNAME = "${}
361  }  }
362    
363    
364  #  Explain usage  #  Explain usage
365  usage()  {  usage()  {
366      echo  cat <<EOF
367      echo "Usage: "$0" [OPTIONS]"  
368      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
369      echo    where [OPTIONS] can be:
370      echo "    -help | --help | -h | --h"  
371      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
372      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
373      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
374      echo "    -pdepend NAME | --pdepend NAME"      -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
375      echo "      -pdepend=NAME | --pdepend=NAME"        -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
376      echo "    -pdefault NAME | --pdefault NAME"            Use "NAME" as the adoptfile.  By default, the file at
377      echo "      -pdefault=NAME | --pdefault=NAME"            "tools/adjoint_options/adjoint_default" will be used.
378      echo "    -make NAME | -m NAME"  
379      echo "      --make=NAME | -m=NAME"      -nooptfile | --nooptfile
380      echo "    -makefile NAME | -mf NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
381      echo "      --makefile=NAME | -mf=NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
382      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"            Use "NAME" as the optfile.  By default, an attempt will be
383      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            made to find an appropriate "standard" optfile in the
384      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"            tools/build_options/ directory.
385      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"  
386      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"      -pdepend NAME | --pdepend NAME
387      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"        -pdepend=NAME | --pdepend=NAME
388      echo "    -disable NAME | --disable NAME"            Get package dependency information from "NAME".
389      echo "      -disable=NAME | --disable=NAME"  
390      echo "    -enable NAME | --enable NAME"      -pdefault NAME | --pdefault NAME
391      echo "      -enable=NAME | --enable=NAME"        -pdefault=NAME | --pdefault=NAME
392      echo "    -standarddirs NAME | --standarddirs NAME"            Get the default package list from "NAME".
393      echo "      -standarddirs=NAME | --standarddirs=NAME"  
394      echo "    -noopt NAME | --noopt NAME"      -make NAME | -m NAME
395      echo "      -noopt=NAME | --noopt=NAME"        --make=NAME | -m=NAME
396  #    echo "    -cpp NAME | --cpp NAME"            Use "NAME" for the MAKE program. The default is "make" but
397  #    echo "      -cpp=NAME | --cpp=NAME"            many platforms, "gmake" is the preferred choice.
398      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"  
399      echo "      -fc=NAME | --fc=NAME"      -makefile NAME | -mf NAME
400      echo "    -[no]ieee | --[no]ieee"        --makefile=NAME | -mf=NAME
401      echo "    -[no]mpi | --[no]mpi"            Call the makefile "NAME".  The default is "Makefile".
402      echo "    -[no]jam | --[no]jam"  
403      echo      -makedepend NAME | -md NAME
404      echo "  and NAME is a string such as:"        --makedepend=NAME | -md=NAME
405      echo            Use "NAME" for the MAKEDEPEND program.
406      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"  
407      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
408      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
409      echo            Specify the location of the MITgcm ROOTDIR as "NAME".
410      echo "  which, depending upon your shell, may need to be single-quoted"            By default, genamke will try to find the location by
411      echo "  if it contains spaces, dashes, or other special characters."            looking in parent directories (up to the 5th parent).
412    
413        -mods NAME | --mods NAME | -mo NAME | --mo NAME
414          -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
415              Here, "NAME" specifies a list of directories that are
416              used for additional source code.  Files found in the
417              "mods list" are given preference over files of the same
418              name found elsewhere.
419    
420        -disable NAME | --disable NAME
421          -disable=NAME | --disable=NAME
422              Here "NAME" specifies a list of packages that we don't
423              want to use.  If this violates package dependencies,
424              genamke will exit with an error message.
425    
426        -enable NAME | --enable NAME
427          -enable=NAME | --enable=NAME
428              Here "NAME" specifies a list of packages that we wish
429              to specifically enable.  If this violates package
430              dependencies, genamke will exit with an error message.
431    
432        -standarddirs NAME | --standarddirs NAME
433          -standarddirs=NAME | --standarddirs=NAME
434              Here, "NAME" specifies a list of directories to be
435              used as the "standard" code.
436    
437        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
438          -fc=NAME | --fc=NAME
439              Use "NAME" as the fortran compiler.  By default, genmake
440              will search for a working compiler by trying a list of
441              "usual suspects" such as g77, f77, etc.
442    
443        -[no]ieee | --[no]ieee
444              Do or don't use IEEE numerics.  Note that this option
445              *only* works if it is supported by the OPTFILE that
446              is being used.
447    
448        -mpi | --mpi
449              Include MPI header files and link to MPI libraries
450        -mpi=PATH | --mpi=PATH
451              Include MPI header files and link to MPI libraries using MPI_ROOT
452              set to PATH. i.e. Include files from $PATH/include, link to libraries
453              from $PATH/lib and use binaries from $PATH/bin.
454    
455        -bash NAME
456              Explicitly specify the Bourne or BASH shell to use
457    
458      While it is most often a single word, the "NAME" variables specified
459      above can in many cases be a space-delimited string such as:
460    
461        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
462        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
463        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
464    
465      which, depending upon your shell, may need to be single-quoted.
466    
467      For more detailed genmake documentation, please see:
468    
469        http://mitgcm.org/devel_HOWTO/
470    
471    EOF
472    
473      exit 1      exit 1
474  }  }
475    
# Line 293  WARNING: Please contact <MITgcm-support@ Line 492  WARNING: Please contact <MITgcm-support@
492  EOF  EOF
493          return 1          return 1
494      fi      fi
495      c_tcall=`nm genmake_test.o | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
496      RETVAL=$?      RETVAL=$?
497      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
498          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 323  WARNING: Please contact <MITgcm-support@ Line 522  WARNING: Please contact <MITgcm-support@
522  EOF  EOF
523          return 1          return 1
524      fi      fi
525      f_tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
526      RETVAL=$?      RETVAL=$?
527      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
528          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 399  EOF Line 598  EOF
598  }  }
599    
600    
601    check_netcdf_libs()  {
602        cat <<EOF > genmake_tnc.for
603          program fgennc
604    #include "netcdf.inc"
605          integer iret, ncid, xid
606          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
607          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
608          iret = nf_def_dim(ncid, 'X', 11, xid)
609          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
610          iret = nf_close(ncid)
611          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
612          end
613    EOF
614        $CPP genmake_tnc.for > genmake_tnc.f  \
615            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
616        RET_COMPILE=$?
617        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
618        RETVAL=$?
619        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
620            HAVE_NETCDF=t
621        else
622            # try again with "-lnetcdf" added to the libs
623            $CPP genmake_tnc.for > genmake_tnc.f  \
624                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
625                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
626            RET_COMPILE=$?
627            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
628            RETVAL=$?
629            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
630                LIBS="$LIBS -lnetcdf"
631                HAVE_NETCDF=t
632            else
633                cat genmake_tnc.log >> genmake_warnings
634            fi
635        fi
636        rm -f genmake_tnc*
637    }
638    
639    
640    
641    ###############################################################################
642    #   Sequential part of script starts here
643    ###############################################################################
644    
645  #  Set defaults here  #  Set defaults here
646  COMMANDL="$0 $@"  COMMANDL="$0 $@"
647    
# Line 407  LN= Line 650  LN=
650  S64=  S64=
651  KPP=  KPP=
652  FC=  FC=
653    CPP=
654  LINK=  LINK=
 # DEFINES="-DWORDLENGTH=4"  
655  DEFINES=  DEFINES=
656  PACKAGES=  PACKAGES=
657  ENABLE=  ENABLE=
# Line 425  FOPTIM= Line 668  FOPTIM=
668  CFLAGS=  CFLAGS=
669  KFLAGS1=  KFLAGS1=
670  KFLAGS2=  KFLAGS2=
671    #LDADD=
672  LIBS=  LIBS=
673  KPPFILES=  KPPFILES=
674  NOOPTFILES=  NOOPTFILES=
675  NOOPTFLAGS=  NOOPTFLAGS=
676    MPI=
677    MPIPATH=
678    
679  # DEFINES checked by test compilation  # DEFINES checked by test compilation
680  HAVE_SYSTEM=  HAVE_SYSTEM=
681  HAVE_FDATE=  HAVE_FDATE=
682  FC_NAMEMANGLE=  FC_NAMEMANGLE=
683  HAVE_CLOC=  HAVE_CLOC=
684    HAVE_NETCDF=
685    HAVE_ETIME=
686    
687  MODS=  MODS=
688  TOOLSDIR=  TOOLSDIR=
689  SOURCEDIRS=  SOURCEDIRS=
690  INCLUDEDIRS=  INCLUDEDIRS=
691  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
692    
693    G2ARGS=
694    BASH=
695  PWD=`pwd`  PWD=`pwd`
696  MAKE=make  MAKE=make
697  AWK=awk  AWK=awk
# Line 457  IEEE= Line 707  IEEE=
707  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
708      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
709  fi  fi
710    FS=
711    FS90=
712    
713  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
714  AD_OPTFILE=  AD_OPTFILE=
# Line 473  TAMC_EXTRA= Line 725  TAMC_EXTRA=
725    
726    
727  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
728  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
729  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
730    
731  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
732  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
733  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
734  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
735  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
736  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
737    
738  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
739  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 491  gm_s12="TAF_EXTRA TAMC_EXTRA" Line 743  gm_s12="TAF_EXTRA TAMC_EXTRA"
743  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
744  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
745    
746    cat <<EOF
747    
748    GENMAKE :
749    
750    A program for GENerating MAKEfiles for the MITgcm project.  For a
751    quick list of options, use "genmake -h" or for more detail see:
752    
753      http://mitgcm.org/devel_HOWTO/
754    
755    EOF
756    
 echo  
757  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
758  gm_local="genmake_local"  gm_local="genmake_local"
759  for i in . $MODS ; do  for i in . $MODS ; do
# Line 501  for i in . $MODS ; do Line 762  for i in . $MODS ; do
762          break          break
763      fi      fi
764  done  done
765  echo -n "  getting local config information:  "  printf "  getting local config information:  "
766  if test -e $gm_local ; then  if test -e $gm_local ; then
767      echo "using $gm_local"      echo "using $gm_local"
768      . $gm_local      . $gm_local
# Line 525  fi Line 786  fi
786  ac_prev=  ac_prev=
787  for ac_option ; do  for ac_option ; do
788    
789        G2ARGS="$G2ARGS \"$ac_option\""
790    
791      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
792      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
793          eval "$ac_prev=\$ac_option"          eval "$ac_prev=\$ac_option"
# Line 546  for ac_option ; do Line 809  for ac_option ; do
809          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
810              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
811                    
812          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
813              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
814          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
815              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 566  for ac_option ; do Line 829  for ac_option ; do
829          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
830              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
831                    
832            -bash | --bash)
833                ac_prev=BASH ;;
834            -bash=* | --bash=*)
835                BASH=$ac_optarg ;;
836            
837            -makedepend | --makedepend | -md | --md)
838                ac_prev=MAKEDEPEND ;;
839            -makedepend=* | --makedepend=* | -md=* | --md=*)
840                MAKEDEPEND=$ac_optarg ;;
841            
842          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
843              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
844          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
845              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
846                    
847          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
848              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
849          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
850              PLATFORM=$ac_optarg ;;              echo
851                usage
852                ;;
853                    
854          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
855              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 601  for ac_option ; do Line 876  for ac_option ; do
876          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
877              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
878    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
879  #           -cpp | --cpp)  #           -cpp | --cpp)
880  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
881  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
# Line 616  for ac_option ; do Line 886  for ac_option ; do
886          -fc=* | --fc=*)          -fc=* | --fc=*)
887              FC=$ac_optarg ;;              FC=$ac_optarg ;;
888                    
889            -fs | --fs)
890                ac_prev=FS ;;
891            -fs=* | --fs=*)
892                FS=$ac_optarg ;;
893            
894            -fs90 | --fs90)
895                ac_prev=FS90 ;;
896            -fs90=* | --fs90=*)
897                FS90=$ac_optarg ;;
898            
899          -ieee | --ieee)          -ieee | --ieee)
900              IEEE=true ;;              IEEE=true ;;
901          -noieee | --noieee)          -noieee | --noieee)
902              IEEE= ;;              IEEE= ;;
903            
904          -mpi | --mpi)          -mpi | --mpi)
905              MPI=true ;;              MPI=true ;;
906          -nompi | --nompi)          -mpi=* | --mpi=*)
907              MPI= ;;              MPIPATH=$ac_optarg
908                MPI=true ;;
909                    
910          -jam | --jam)  #       -jam | --jam)
911              JAM=1 ;;  #           JAM=1 ;;
912          -nojam | --nojam)  #       -nojam | --nojam)
913              JAM=0 ;;  #           JAM=0 ;;
914                    
915          -ds | --ds)          -ds | --ds)
916              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 677  if test "x${ROOTDIR}" = x ; then Line 958  if test "x${ROOTDIR}" = x ; then
958          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
959              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
960                  ROOTDIR=$d                  ROOTDIR=$d
961                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
962                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
963                  break                  break
964              fi              fi
# Line 711  if test "x$OPTFILE" != xNONE ; then Line 992  if test "x$OPTFILE" != xNONE ; then
992          . "$OPTFILE"          . "$OPTFILE"
993          RETVAL=$?          RETVAL=$?
994          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
995              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
996              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
997              exit 1              exit 1
998          fi          fi
# Line 724  if test "x$OPTFILE" != xNONE ; then Line 1005  if test "x$OPTFILE" != xNONE ; then
1005      fi      fi
1006  fi  fi
1007    
1008    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1009    # check_for_broken_Ff
1010    
1011  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1012  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1013      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 738  if test "x${AD_OPTFILE}" != xNONE ; then Line 1022  if test "x${AD_OPTFILE}" != xNONE ; then
1022          . "$AD_OPTFILE"          . "$AD_OPTFILE"
1023          RETVAL=$?          RETVAL=$?
1024          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1025              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1026              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1027              exit 1              exit 1
1028          fi          fi
# Line 753  fi Line 1037  fi
1037    
1038  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1039  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1040    if test ! "x$BASH" = x ; then
1041        # add a trailing space so that it works within the Makefile syntax (see below)
1042        BASH="$BASH "
1043    fi
1044  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1045      cat <<EOF 1>&2      cat <<EOF 1>&2
1046    
# Line 766  fi Line 1054  fi
1054  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1055      LINK=$FC      LINK=$FC
1056  fi  fi
 if test "x$CPP" = x ; then  
     CPP="cpp"  
 fi  
1057  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
1058      MAKE="make"      MAKE="make"
1059  fi  fi
1060    if test "x$CPP" = x ; then
1061        CPP=cpp
1062    fi
1063    #EH3 === UGLY ===
1064    #  The following is an ugly little hack to check for $CPP in /lib/ and
1065    #  it should eventually be replaced with a more general function that
1066    #  searches a combo of the user's path and a list of "usual suspects"
1067    #  to find the correct location for binaries such as $CPP.
1068    for i in " " "/lib/" ; do
1069        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1070    done
1071    #EH3 === UGLY ===
1072  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
1073  RETVAL=$?  RETVAL=$?
1074  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 808  EOF Line 1105  EOF
1105  fi  fi
1106  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1107    
1108    #  Check for broken *.F/*.f handling and fix if possible
1109    check_for_broken_Ff
1110    
1111    if test ! "x$MPI" = x ; then
1112          echo "  Turning on MPI cpp macros"
1113          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1114    fi
1115    
1116  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1117  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1118  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1119        program hello        program hello
1120        call system('echo hi')        call system('echo hi')
# Line 828  else Line 1132  else
1132  fi  fi
1133  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1134    
1135  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1136  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1137        program hello        program hello
1138        CHARACTER(128) string        CHARACTER(128) string
# Line 849  else Line 1153  else
1153  fi  fi
1154  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1155    
1156  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1157    cat > genmake_tcomp.f <<EOF
1158          program hello
1159          REAL*4 ACTUAL, TARRAY(2)
1160          EXTERNAL ETIME
1161          REAL*4 ETIME
1162          actual = etime( tarray )
1163          print *, tarray
1164          end
1165    EOF
1166    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1167    RETVAL=$?
1168    if test "x$RETVAL" = x0 ; then
1169        HAVE_ETIME=t
1170        DEFINES="$DEFINES -DHAVE_ETIME"
1171        echo "yes"
1172    else
1173        HAVE_ETIME=
1174        echo "no"
1175    fi
1176    rm -f genmake_tcomp*
1177    
1178    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1179  check_HAVE_CLOC  check_HAVE_CLOC
1180  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1181      echo "yes"      echo "yes"
1182  else  else
1183      echo "no"      echo "no"
1184  fi  fi
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
 fi  
1185  rm -f genmake_t*  rm -f genmake_t*
1186    
1187    printf "  Can we create NetCDF-enabled binaries...  "
1188    check_netcdf_libs
1189    if test "x$HAVE_NETCDF" != x ; then
1190        echo "yes"
1191    else
1192        echo "no"
1193    fi
1194    
1195    
1196  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1197  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1198  for d in $MODS ; do  for d in $MODS ; do
1199      if test ! -d $d ; then      if test ! -d $d ; then
1200          echo          echo
1201          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1202          exit 1          exit 1
1203      else      else
1204          echo -n " $d"          printf " $d"
1205          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1206          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1207      fi      fi
# Line 903  if test "x${TOOLSDIR}" = x ; then Line 1231  if test "x${TOOLSDIR}" = x ; then
1231      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1232  fi  fi
1233  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1234      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1235      exit 1      exit 1
1236  fi  fi
1237  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1238      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
1239  fi  fi
1240    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1241    
1242  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1243    
# Line 923  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1252  if test -r $ROOTDIR"/eesupp/src/Makefile
1252          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1253      else      else
1254          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1255          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1256          exit 1          exit 1
1257      fi      fi
1258  fi  fi
1259    
1260    #same for exch2
1261    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1262        echo "  Making source files in exch2 from  templates"
1263        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1264        RETVAL=$?
1265        if test "x${RETVAL}" = x0 ; then
1266            rm -f make_exch2.errors
1267        else
1268            echo "Error: problem encountered while building source files in exch2:"
1269            cat make_exch2.errors 1>&2
1270            exit 1
1271        fi
1272    fi
1273    
1274  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1275  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1276      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 960  rm -f ./.pd_tmp Line 1303  rm -f ./.pd_tmp
1303  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1304  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1305  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1306  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1307  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1308      for i in "." $MODS ; do      for i in "." $MODS ; do
1309          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 973  if test "x${PDEFAULT}" = x ; then Line 1316  if test "x${PDEFAULT}" = x ; then
1316      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1317  fi  fi
1318  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1319      echo "default packages file disabled"      echo "    default packages file disabled"
1320  else  else
1321      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1322          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1323      else      else
1324          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1325          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1326          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1327          RETVAL=$?          RETVAL=$?
1328          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1329              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1330              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1331              exit 1              exit 1
1332          fi          fi
# Line 992  else Line 1334  else
1334              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1335          done          done
1336          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1337          expand_pkg_groups          while ! expand_pkg_groups; do echo > /dev/null; done
1338          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1339      fi      fi
1340  fi  fi
1341    
1342  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1343    for i in $PACKAGES ; do
1344        echo $i >> ./.tmp_pack
1345    done
1346    for i in `grep  "-" ./.tmp_pack` ; do
1347        j=`echo $i | sed 's/[-]//'`
1348        DISABLE="$DISABLE $j"
1349    done
1350  pack=  pack=
1351  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1352      addit="t"      addit="t"
# Line 1014  PACKAGES="$pack" Line 1363  PACKAGES="$pack"
1363  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1364  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1365  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1366    # Test if each explicitly referenced package exists
1367  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1368      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1369        if test ! -d "$ROOTDIR/pkg/$j" ; then
1370          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1371          exit 1          exit 1
1372      fi      fi
1373      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1374  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1375  PACKAGES=  PACKAGES=
1376  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1377      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1378  done  done
1379    rm -f ./.tmp_pack
1380  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1381    
1382  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 1112  for i in $PACKAGES ; do Line 1462  for i in $PACKAGES ; do
1462      fi      fi
1463  done  done
1464    
1465    #  Build MNC templates and check for ability to build and use NetCDF
1466    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1467    RETVAL=$?
1468    if test "x$RETVAL" = x0 ; then
1469        ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1470        RETVAL=$?
1471        if test "x${RETVAL}" = x0 ; then
1472            rm -f make_mnc.errors
1473        else
1474            echo "Error: problem encountered while building source files in pkg/mnc:"
1475            cat make_mnc.errors 1>&2
1476            exit 1
1477        fi
1478        if test "x$HAVE_NETCDF" != xt ; then
1479            cat <<EOF
1480    
1481  # Create a list of #define and #undef to enable/disable packages  WARNING: the "mnc" package has been enabled but tests failed to
1482  PACKAGES_DOT_H=PACKAGES_CONFIG.h    compile and/or execute NetCDF applications.  Please check that:
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
   
 #ifndef PACKAGES_H  
 #define PACKAGES_H  
1483    
1484  C  Packages disabled by genmake:    1) NetCDF is installed for your compiler and
1485      2) the LIBS variable (within the 'optfile") specifies the correct
1486           NetCDF library to link against.
1487      
1488  EOF  EOF
1489        fi
1490    fi
1491    
1492    # Create a list of #define and #undef to enable/disable packages
1493    PACKAGES_DOT_H=PACKAGES_CONFIG.h
1494  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1495  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1496  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1497  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1498  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1499  all_pack=  all_pack=
1500    DISABLED_PACKAGES=
1501  for n in $names ; do  for n in $names ; do
1502      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1503          has_pack="f"          has_pack="f"
# Line 1144  for n in $names ; do Line 1509  for n in $names ; do
1509          done          done
1510          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1511              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1512              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
1513          fi          fi
1514      fi      fi
1515  done  done
1516  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1517  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1518      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1519      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1520  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1521    
1522  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1523      case $i in      case $i in
1524          aim_v23)          aim_v23)
1525              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1526              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1527              ;;              ;;
1528      esac      esac
1529  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1530    
1531  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1532    
1533  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1534  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1535  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1536      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1537  fi  fi
1538  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1539      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1540      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1541          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1542          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1543          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1544      else              exit 1
1545          SOURCEDIRS="$SOURCEDIRS $adr"          else
1546      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1547      adr="$ROOTDIR/$d/inc"          fi
1548      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1549          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1550          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1551          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1552      else              exit 1
1553          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1554      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1555  done          fi
1556        done
1557    fi
1558    
1559  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1560  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1561  CPP_OPTIONS=  CPP_OPTIONS=
1562    CPP_EEOPTIONS=
1563  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1564    names=`ls -1 "$ROOTDIR/pkg"`
1565  for i in $spaths ; do  for i in $spaths ; do
1566      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1567      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1568          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1569          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1570          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1571            for n in $names ; do
1572                test_for_package_in_cpp_options $CPP_OPTIONS $n
1573            done
1574        fi
1575        try="$i/CPP_EEOPTIONS.h"
1576        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1577            echo "    found CPP_EEOPTIONS=\"$try\""
1578            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1579    #**** not yet enabled ****
1580    #        test_for_mpi_in_cpp_eeoptions $try
1581    #**** not yet enabled ****
1582            CPP_EEOPTIONS="$try"
1583      fi      fi
1584  done  done
1585  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1586      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1587      exit 1      exit 1
1588  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1589    
1590  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1591  #  compiler.  #  compiler.
# Line 1247  for i in $SOURCEDIRS ; do Line 1600  for i in $SOURCEDIRS ; do
1600      done      done
1601  done  done
1602    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
1603    
1604  echo  echo
1605  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1275  rm -rf .links.tmp Line 1617  rm -rf .links.tmp
1617  mkdir .links.tmp  mkdir .links.tmp
1618  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1619  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1620  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1621  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1622  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1623  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1624  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1625  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1626  for d in $alldirs ; do  for d in $alldirs ; do
1627      deplist=      deplist=
# Line 1288  for d in $alldirs ; do Line 1630  for d in $alldirs ; do
1630      for sf in $sfiles ; do      for sf in $sfiles ; do
1631          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1632              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1633                    case $d/$sf in
1634                      ./$PACKAGES_DOT_H)
1635                            ;;
1636                      ./AD_CONFIG.h)
1637                            ;;
1638                      ./FC_NAMEMANGLE.h)
1639                            ;;
1640                      *)
1641                            touch .links.tmp/$sf
1642                            deplist="$deplist $sf"
1643                            ;;
1644                    esac
1645                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
                 touch .links.tmp/$sf  
                 deplist="$deplist $sf"  
1646                  case $extn in                  case $extn in
1647                      F)                      F)
1648                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1649                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1650                          ;;                          ;;
1651                      F90)                      F90)
1652                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1653                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1654                          ;;                          ;;
1655                      c)                      c)
1656                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1657                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1658                          ;;                          ;;
1659                      h)                      h)
1660                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1661                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1662                          ;;                          ;;
1663                      flow)                      flow)
1664                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1665                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1666                          ;;                          ;;
1667                  esac                  esac
1668              fi              fi
# Line 1339  echo "#    $MACHINE" >> $MAKEFILE Line 1691  echo "#    $MACHINE" >> $MAKEFILE
1691  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1692  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1693  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1694  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1695  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1696  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1697    
# Line 1348  EXE_FTL=$EXECUTABLE"_ftl" Line 1700  EXE_FTL=$EXECUTABLE"_ftl"
1700  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1701    
1702  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1703    #
1704    # OPTFILE="$OPTFILE"
1705  #  #
1706  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1707  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1381  EXE_AD      = ${EXE_AD} Line 1735  EXE_AD      = ${EXE_AD}
1735  EXE_FTL     = ${EXE_FTL}  EXE_FTL     = ${EXE_FTL}
1736  EXE_SVD     = ${EXE_SVD}  EXE_SVD     = ${EXE_SVD}
1737    
1738    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1739    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1740    
1741    # These files are created by Makefile
1742    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1743    
1744  EOF  EOF
1745    
1746  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1399  FC = ${FC} Line 1759  FC = ${FC}
1759  # Fortran compiler  # Fortran compiler
1760  F90C = ${F90C}  F90C = ${F90C}
1761  # Link editor  # Link editor
1762  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1763    
1764  # Defines for CPP  # Defines for CPP
1765  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1431  cat csrclist.inc      >> $MAKEFILE Line 1791  cat csrclist.inc      >> $MAKEFILE
1791  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1792  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1793  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1794  echo               >> $MAKEFILE  echo >> $MAKEFILE
1795  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1796  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1797  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1798    echo >> $MAKEFILE
1799    echo '.SUFFIXES:' >> $MAKEFILE
1800    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
1801  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1802  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
1803    
1804  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1805    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1806  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1807  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1808            @echo Creating \$@ ...
1809          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1810  depend:  depend:
1811          @make links          @make links
1812          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1813          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1814            -rm -f makedepend.out
1815    
1816  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1817    
1818  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1819    
# Line 1461  output.txt: \$(EXECUTABLE) Line 1822  output.txt: \$(EXECUTABLE)
1822          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1823    
1824  clean:  clean:
1825          -cat AD_CONFIG.template > AD_CONFIG.h          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
         -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}  
1826  Clean:  Clean:
1827          @make clean          @make clean
1828          @make cleanlinks          @make cleanlinks
1829          -rm -f Makefile.bak genmake_state genmake_*optfile make.log          -rm -f \$(SPECIAL_FILES)
1830            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1831  CLEAN:  CLEAN:
1832          @make Clean          @make Clean
1833          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1834          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1835          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1836          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1837    
1838  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1839  makefile:  makefile:
1840          ${0} $@          $THIS_SCRIPT $G2ARGS
1841  cleanlinks:  cleanlinks:
1842          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1843    
1844  # The normal chain of rules is (  .F - .f - .o  )  # Special targets ($SPECIAL_FILES) which are create by make
1845  .F.f:  ${PACKAGES_DOT_H}:
1846            @echo Creating \$@ ...
1847            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1848    AD_CONFIG.h:
1849            @echo Creating \$@ ...
1850            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1851    FC_NAMEMANGLE.h:
1852            @echo Creating \$@ ...
1853            echo "$FC_NAMEMANGLE" > \$@
1854    
1855    # The normal chain of rules is (  .F - .$FS - .o  )
1856    
1857    %.o : %.F
1858    
1859    .F.$FS:
1860          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1861  .f.o:  .$FS.o:
1862          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1863  .F90.f90:  .F90.$FS90:
1864          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1865  .f90.o:  .$FS90.o:
1866          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1867  .c.o:  .c.o:
1868          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1869    
1870  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1871  .F.p:  .F.p:
1872          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1873  .p.f:  .p.$FS:
1874          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1875    
1876  #=========================================  #=========================================
# Line 1522  done Line 1897  done
1897    
1898  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
1899  echo >> $MAKEFILE  echo >> $MAKEFILE
1900  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
1901  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
1902  for i in $AD_FILES ; do  for i in $AD_FILES ; do
1903      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
1904      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
1905  done  done
1906  echo >> $MAKEFILE  echo >> $MAKEFILE
1907  rm -f ad_files  rm -f ad_files
# Line 1539  adtaf: ad_taf_output.f Line 1914  adtaf: ad_taf_output.f
1914  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1915    
1916  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1917            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1918          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1919            -rm -f ad_config.template
1920          @make \$(F77FILES)          @make \$(F77FILES)
1921          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1922          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1923    
1924  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
1925          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1926          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1927    
1928  adtafonly:  adtafonly:
1929          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1930          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1931    
1932  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
1933          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1934    
1935  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
1936          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1937          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1938    
1939  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
1940          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 1569  ftltaf: ftl_taf_output.f Line 1946  ftltaf: ftl_taf_output.f
1946  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1947    
1948  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1949            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1950          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1951            -rm -f ftl_config.template
1952          @make \$(F77FILES)          @make \$(F77FILES)
1953          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1954          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1955    
1956  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.f: ftl_input_code.f
1957          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1958          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1959    
1960    ftltafonly:
1961            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1962            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1963    
1964  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
1965          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1966    
1967  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.f: ftl_input_code.f
1968          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1969          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1970    
1971  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1972          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1973    
1974    
1975  # ... SVD ...  # ... SVD ...
1976  svd: svd_taf  svdtaf: ad_taf_output.f ftl_taf_output.f
1977  svd_taf_f: svd_taf_output.f  svdall: svd_taf
   
 svd_input_code.f: \$(SRCFILES)  
         cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h  
         @make \$(F77FILES)  
         @make \$(AD_FLOW_FILES)  
         cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f  
   
 svd_taf_output.f: svd_input_code.f  
         \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f  
         cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f  
1978    
1979  svd_taf: svd_taf_output.o \$(OBJFILES)  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
1980          \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
1981    
1982    
1983  #=========================================  #=========================================
# Line 1622  for i in $KPPFILES ; do Line 1995  for i in $KPPFILES ; do
1995      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
1996          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
1997      fi      fi
1998      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
1999  done  done
2000    
2001  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1632  for i in $NOOPTFILES ; do Line 2005  for i in $NOOPTFILES ; do
2005      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2006          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2007      fi      fi
2008      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2009      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2010  done  done
2011    
# Line 1645  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2018  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2018    
2019  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2020    
2021  #  Write the "template" files for the adjoint builds  # Create special header files
2022  cat >AD_CONFIG.template <<EOF  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2023  C  WARNING: This file is automatically generated by genmake2 and  if test ! -f $PACKAGES_DOT_H ; then
2024  C    used by the Makefile rules.  Please DO NOT EDIT this file      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2025  C    unless you are CERTAIN that you know what you are doing.  else
2026        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2027  #undef ALLOW_ADJOINT_RUN      RETVAL=$?
2028  #undef ALLOW_TANGENTLINEAR_RUN      if test "x$RETVAL" = x0 ; then
2029  #undef ALLOW_ECCO_OPTIMIZATION          rm -f $PACKAGES_DOT_H".tmp"
2030  EOF      else
2031  cat >ad_config.template <<EOF          mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
2032  C  WARNING: This file is automatically generated by genmake2 and          mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2033  C    used by the Makefile rules.  Please DO NOT EDIT this file      fi
2034  C    unless you are CERTAIN that you know what you are doing.  fi
2035    if test ! -f AD_CONFIG.h ; then
2036  #define ALLOW_ADJOINT_RUN      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2037  #undef ALLOW_TANGENTLINEAR_RUN  fi
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >ftl_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #define ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >svd_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #undef ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cp AD_CONFIG.template AD_CONFIG.h  
2038    
2039    
2040  #  Write the "state" for future records  #  Write the "state" for future records
2041  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2042      echo -n "" > genmake_state      printf "" > genmake_state
2043      for i in $gm_state ; do      for i in $gm_state ; do
2044          t1="t2=\$$i"          t1="t2=\$$i"
2045          eval $t1          eval $t1

Legend:
Removed from v.1.39  
changed lines
  Added in v.1.83

  ViewVC Help
Powered by ViewVC 1.1.22